import requests
from common_utils import *


def get_cautoken():
    auth = 'REFJVkJBRE1fTUlDVE1fQ05fTk9OUFJPRF8wMDQxMzo2YjlvNzNScjE0RHM1Xy53dU1ncUx+cC1DMEo4WGwybQ=='
    scope = 'openid groups audience:server:client_id:DAIVBADM_CAU_CN_NONPROD_00000 heron:{region=CN,stage=NONPROD}miccm:auth.authorizations-api.v4.authorizations:get heron:{region=CN,stage=NONPROD}miccm:auth.authorizations-api.v4.authorizations.authorizationid:get'
    resBody = getToken(auth, scope).json()
    return resBody['id_token']


def get_authorizations(vin):
    requests.packages.urllib3.disable_warnings(requests.packages.urllib3.exceptions.InsecureRequestWarning)

    url = 'https://auth-nonprod.query.api.dvb.corpinter.net.cn/authorizations-api/v4/authorizations?finOrVin=' + vin

    headers = {
        'X-TrackingId': 'nfs123',
        'X-ApplicationName': 'mbstore',
        'Authorization': 'Bearer ' + get_cautoken()
    }

    res = requests.get(url, headers=headers, verify=False, proxies=proxyDict)
    #res = requests.get(url, headers=headers, verify=False, proxies=proxyDict, hooks={'response': print_roundtrip})

    if res.status_code != 200:
        print('[ERROR]failed to get CAU token')
        return None

    return res.json()


def getusers(vin):
    result = get_authorizations(vin)
    if not result: return None

    resultCount = result['resultCount']
    if resultCount == 0:
        print('[WARN]vin has no users')
        return None, []

    authorizations = result['authorizations']

    masteruser = None
    otherusers = []
    for i in range(0, resultCount):
        if (authorizations[i]['vehicleOwner']):
            masteruser = authorizations[i]['meId']
            #users.insert(0, authorizations[i]['meId'])
        else:
            otherusers.append(authorizations[i]['meId'])
    otherusers.append("GUEST")

    return masteruser, otherusers

#print(getusers('W1KMJ5AB9RF000350'))